.Macro ld_r 
	.if @1 < 0x40
		in		@0,@1
	.else
		lds		@0,@1
	.endif
.Endmacro

.Macro ld_X
		ldi    XL, LOW(@0)
        ldi    XH, HIGH(@0)		         
.Endmacro

.Macro ld_Y 
		ldi    YL, LOW(@0)
        ldi    YH, HIGH(@0)		         
.Endmacro

.Macro ld_Z 
		ldi    ZL, LOW(@0)
        ldi    ZH, HIGH(@0)		         
.Endmacro

.Macro ld_t1
		ld_r	t1,@0
.Endmacro

.Macro st_t1 
		st_r	@0,t1
.Endmacro

.Macro st_r 
	.if @0 < 0x40
		out		@0,@1
	.else
		sts		@0,@1
	.endif
.Endmacro

.Macro st_0
		st_r 	@0,r_zero
.Endmacro

.Macro st_v						;NICHT IN INTERRUPTS VERWENDEN / T1 WIRD GENDERT!
		ldi 	t1,@1
		st_r 	@0,t1
.Endmacro

.Macro st_w						;NICHT IN INTERRUPTS VERWENDEN / T1 WIRD GENDERT!
		st_v 	@0H,HIGH(@1) 
		st_v 	@0L,LOW(@1)		
.Endmacro

.Macro Int_Start
	in		r_SREG,SREG
.Endmacro

.Macro Int_End
	out		SREG, r_SREG
	reti
.Endmacro

.Macro Set_TWI_Mode
	ldi  	Modus,@0
	st_r	TWI_Modus,Modus
	st_0	TWI_Frame
.Endmacro

.Macro Inc_Addr
	lds		@0,@1
	inc		@0
	sts		@1,@0
.Endmacro

.Macro Clear_RAM
			clr		r_zero
			ld_Z	0
Reg_Init:	st 	 	Z+,r_zero
			cpi  	ZL,30	brne 	Reg_Init

			ld_Z  	SRAM_START		
Ram_Init:	st 	 	Z+,r_zero
			cpi  	ZH,high(RAMEND+1)	brne 	Ram_Init 
.Endmacro

.Macro Init_Watchdog_250ms
		ld_t1	WDTCSR				    						;Sequenz notwendig um den Prescaler ndern zu knnen
		ori  	t1,(1<<WDCE)|(1<<WDE)
		st_t1	WDTCSR
		st_v	WDTCSR,(1<<WDIE)|(1<<WDP2)						;Watchdog Interrupt enabled / 0,25 Sekunden	
.Endmacro

.Macro MoveBits
		bst		@0,@1	bld		@2,@3
.Endmacro

